# Copyright 2016 Red Hat, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#
# Refer to the README and COPYING files for full details of the license

%define        __spec_install_post %{nil}
%define          debug_package %{nil}
%define        __os_install_post %{_dbpath}/brp-compress

# define the python package prefix based on distribution version
# this is needed to require a correct python-openvswitch package:
# python-openvswitch or python3-openvswitch for fedora >=28 or
# el >= 8
%if 0%{?fedora} >= 28 || 0%{?rhel} >= 8
%global required_python python%{python3_pkgversion}
%global required_python_interpreter %{__python3}
%define required_python_lib(l:) python%{python3_pkgversion}-%{*}
%define _py2 python2
%else
%global required_python python
%global required_python_interpreter %{__python2}
%define required_python_lib(l:) %{-l*}%{*}
%define _py2 python
%endif

%global required_ovs_lib %{required_python_lib -l python- openvswitch}
%global required_six_lib %{required_python_lib -l python- six}
%global required_ovsdbapp_lib %{required_python_lib -l python- ovsdbapp}
%global required_requests_lib %{required_python_lib -l python- requests}
%global required_netaddr_lib %{required_python_lib -l python- netaddr}

Name:           ovirt-provider-ovn
Version:        1.2.23
Release:        0.20190530082947.gite048a1940a%{?dist}
Summary:        The oVirt external network provider for OVN
License:        GPLv2+
BuildArch:      noarch
URL:            https://gerrit.ovirt.org/#/admin/projects/ovirt-provider-ovn
Source0:        %{name}-%{version}.tar.gz

Requires: firewalld-filesystem
Requires: kernel >= 3.10.0-512

Requires: openvswitch >= 0:2.7
Requires: openvswitch-ovn-central >= 0:2.7
Requires: openvswitch-ovn-common >= 0:2.7
Requires: %{required_ovs_lib} >= 0:2.7

Conflicts: openvswitch = 1:2.6.1
Conflicts: openvswitch-ovn-central = 1:2.6.1
Conflicts: openvswitch-ovn-common = 1:2.6.1
Conflicts: %{required_ovs_lib} = 1:2.6.1

Requires: %{required_requests_lib}
Requires: %{required_netaddr_lib}
Requires: %{required_ovsdbapp_lib}
Requires: %{required_six_lib}

BuildRequires: python
BuildRequires: systemd

%prep
%setup -q

%build

%install
rm -rf $RPM_BUILD_ROOT
%make_install PYTHON="%{required_python_interpreter}"


%description
The oVirt external network provider for OVN allows to integrate oVirt with the
Open vSwitch Open Virtual Network (OVN) solution. OVN is a Software Defined
Networking extension to Open vSwitch. OVN is integrated into oVirt using the
external network API. The oVirt provider for OVN serves as a proxy between
oVirt engine and OVN Northbound DB.

%post
%systemd_post ovirt-provider-ovn.service


%preun
%systemd_preun ovirt-provider-ovn.service


%postun
%systemd_postun_with_restart ovirt-provider-ovn.service


%package driver
Summary: The virtual interface driver for oVirt external network provider for OVN
License: GPLv2+
BuildArch: noarch
Requires: firewalld-filesystem
Requires: kernel >= 3.10.0-512

Requires: openvswitch >= 0:2.7
Requires: openvswitch-ovn-host >= 0:2.7
Requires: openvswitch-ovn-common >= 0:2.7
Requires: %{_py2}-openvswitch >= 0:2.7

Conflicts: openvswitch = 1:2.6.1
Conflicts: openvswitch-ovn-host = 1:2.6.1
Conflicts: openvswitch-ovn-common = 1:2.6.1
Conflicts: %{_py2}-openvswitch = 1:2.6.1

Requires: vdsm
Requires(post): firewalld-filesystem


%description driver
The virtual interface driver for oVirt external network provider for OVN.
The driver handles the connection of virtual NICs provisioned on oVirt hosts
to OVN.


%files
%config(noreplace) %{_sysconfdir}/ovirt-provider-ovn
%config(noreplace) %{_sysconfdir}/logrotate.d/ovirt-provider-ovn
%{_datadir}/ovirt-provider-ovn
%{_unitdir}/ovirt-provider-ovn.service
/usr/lib/firewalld/services/ovirt-provider-ovn.xml
%doc /usr/share/doc/ovirt-provider-ovn/README.adoc
%license LICENSE

%files driver
%{_libexecdir}/vdsm/hooks/before_nic_hotplug/*
%{_libexecdir}/vdsm/hooks/before_device_create/*
%{_libexecdir}/vdsm/hooks/after_get_caps/*
%{_libexecdir}/vdsm/hooks/after_vm_destroy/*
%{_libexecdir}/vdsm/vhostuser_permissions_setter
%{_libexecdir}/ovirt-provider-ovn
%{python_sitelib}/vdsm/tool/ovn_config.py*
%{_sysconfdir}/sudoers.d/50_vdsm_hook_ovirt_provider_ovn_hook
%license LICENSE


%changelog
* Thu May 09 2019 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1.2.22
- fix error handling on python3
- fix error where ipv6 subnets could not be removed from routers
- implement default keystone route

* Thu Apr 11 2019 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1.2.21
- stateless dhcpv6 on ipv6 subnets
- package the provider for python3 - on fedora / el8
- fix IPv6 subnet gateway
- bail out of driver after_get_caps hooks when ovs is not available

* Mon Feb 18 2019 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1.2.20
- fix dhcpv6 options
- default security group rule ethertype to IPv4

* Tue Jan 22 2019 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1.2.19
- subnet ipv6 support
- fix disabling port security on logical ports

* Mon Jan 14 2019 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1.2.18
- configurable TLS ciphers
- comply with networking API on network updates
- comply with networking API on port creation

* Wed Nov 15 2018 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1.2.17
- comply with the networking api for security group rule GET requests
- implement the remote group prefix parameter for security groups
- implement the acls in the correct OVS pipeline stage
- support unicode characters on security group names
- support unicode characters on network names

* Wed Oct 03 2018 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1.2.16
- add security group support on the provider

* Mon Mar 13 2017 Dominik Holler <dholler@redhat.com> - 1.1
- add dependecy python-requests

* Fri Aug  26 2016 Marcin Mirecki
-
